;
;	>>> ISO by JAC! <<<
;
;	An 8k demo for the Atari 2600.
;	Created for Sillyventure 2011 in Gdansk.
;	V1.0-2011-11-10 (party version)
;	V1.1-2011-11-15 (15kHz AUDVx fix)
;	V1.2-2012-12-19 (loop version)
;
;	Code and graphics by JAC!, sound by Jakub Husak.
;
;	This is my second Atari 2600 demo and it was a tough journey.
;	Anybody who thinks retro coding is simple should give this machine a try.
;
;	I wanted to create a demo which is different from existing "typical VCS"
;	demos which tend to use full screen effects at low resolutions without
;	transitions but with HMOVE artifacts on the left side of the screen.
;	I wanted to establish the classical logo/playfield/credits screen
;	layout from the good old days of the cracktros and Amiga intros. 
;	Ironically on VCS this is much harder than full screen effects :-)
;	I wanted to create smooth effects which appear to be in multicolor hires
;	resolution on a machine with 21 bits of screen RAM and 8+8+1+1+1 movable pixels.
;	I also wanted as many effects as possible in 8k with a fast pace and
;	proper transitions. The complete lack of interrupts makes the last
;	one especially hard and expensive in terms of RAM and ROM usage.
; 
;	I'm fucking proud of the result and I hope you like it a bit, too.
;
;	ISO Logo
;	========
;	Isometric 3D logo in 92x84 multicolor hires pixels with time dependent shading and flexible height.
;
;	Floating and Falling Text Tiles
;	===============================
;	Text engine which draws arbitrary text in a virtual 160x60 pixels area (double scan lines).
;	Up to three parallel drawing threads running at 50 FPS.
;	Support for visual fading in, fork and join.
;	Text is transformed dynamically into falling tiles of 4x18 or 4x16 pixels.
;	Falling tiles are subject to gravity and bounce of the left/right screen boundary.
;	Falling tiles fade out while they approach the bottom of the screen.
;
;	Ribbon
;	======
;	Mirrored sin-sin double ribbon in 144x157 pixels resolution (single scan lines).
;	X-positions translated to full PAL palette (single scan lines).
;	Presented with 3 different speed and color variations at 50 FPS.
;	
;	Plasma
;	======
;	10x26 pixel, full 104 color plasma running at 50 FPS.
;	sin(x)+sin(y) movement translated to full PAL palette in three variations.
;
;	Twist
;	=====
;	Shaded twister in 44x158 pixels resolution (double scan lines).
;	Variable X-positioning and black 8 pixel shade.
;	Presented with 3 different speed, color and movement variations at 50 FPS.
;
;	Twirl
;	=====
;	10x26 interleaved pixels mode for virtual 20x26 pixel resolution.
;	Full 104 colors twirl running at 50 FPS.
;	Rotator, circle zoom and spiral variations translated to full PAL palette.
;
;	Scroll
;	======
;	Scrolling "Sillyventure" logo with 104 colors in 64x7 blocks at 50 FPS. 
;	Scrolling resolution 160x156 pixels, 3 pixel horizontal resolution
;	Black, flashing, cycling logo colors.
;	Flexible line height (single scan lines) and color bar background.
;
;	Thanks to:
;	==========
;	- Grey/MSB for organizing Sillyventure and being so crazy as to start a VCS demo compo
;	  ... and for stretching the deadline
;	- Jakub Husak for the great tune
;	  ... and the player additions .. and keeping the deadline ... eventually :-)
;	- d-wilson for finding the article on "Why 2:16 minutes" again
;	  ... though the demo now takes 3:31 in the end. I had too many effecs :-)
;
;	Greetings an respect to:
;	========================
;	Noice (cool ideas), Trilobit (cool stories), Tjoppen (cool execution)
;	and all people at Sillyventure - one day I'll be there, too.
;
;	@com.wudsn.ide.asm.hardware=ATARI2600

; Screen:
; Type        NTSC  PAL/SECAM
; V-Sync      3     3    scanlines
; V-Blank     37    45   scanlines (upper border)
; Picture     192   228  scanlines
; Overscan    30    36   scanlines (lower border)
; Frame Rate  60    50   Hz
; Frame Time  262   312  scanlines
;
; Stella Screeenshot: 320x250
; V-Sync + V-Blank = 12 lines
; White line in line 12
; Playfield = 228 lines
; Overscan = 10 lines
; White lines = 12, 78, 239 | 7, 73, 234


	icl "ISO-Cart-Part1.asm"
	icl "ISO-Cart-Bank1.asm"
	icl "ISO-Cart-Part2.asm"
	icl "ISO-Cart-Bank2.asm"
	icl "ISO-Cart-Part3.asm"

	